// ##################
// Programm SimpleRSA
// ##################
// Erstellt von Jens Scheffler zur Demonstration
// des RSA-Algorithmus           02.01.2001-

//Includes
#include <stdio.h>
#include "VeryLong.h"
#include "Primzahlen.h"
#include "Key.h"
#include "Nachricht.h"
#define UNREFERENCED_PARAMETER(P)          (P)

void PrimZahlenProg(Primzahlen **prim);
void KeyProg(Primzahlen *primy);
void NachrichtProg(Nachricht **msg);

//Hauptprogramm
int main(int argc, char** argv)
{
    UNREFERENCED_PARAMETER(argc);
    UNREFERENCED_PARAMETER(argv);

	//Variablendeklarationen
	Primzahlen *prim;
	prim=new Primzahlen;
	Nachricht *msg;
	msg=new Nachricht;

	//Hauptmen
	char Auswahl;
	do
	{
		printf("\n\n\n\n\n\tHauptmenue SimpleRSA");
		printf(        "\n\t====================");
		printf(      "\n\n\t1) Primzahlen...");
		printf(        "\n\t2) Schluesselgenerator...");
		printf(        "\n\t3) Ver-/Entschluesseln von Nachrichten...");
		printf(      "\n\n\t0) Beenden");
		printf(      "\n\n\tAuswahl: ");

		Auswahl=(char)getchar();

		switch (Auswahl)
		{
		case '1':
			PrimZahlenProg(&prim);
			break;
		case '2':
			KeyProg(prim);
			break;
		case '3':
			NachrichtProg(&msg);
			break;
		case '4':
			VeryLong basis;
			VeryLong potenz;
			VeryLong modu;
			VeryLong erg;
			char modulo[11];
			modulo[0]='0';
			modulo[1]='3';
			modulo[2]='0';
			modulo[3]='8';
			modulo[4]='5';
			modulo[5]='6';
			modulo[6]='0';
			modulo[7]='E';
			modulo[8]='0';
			modulo[9]='5';
			modulo[10]='\0';
			basis=54;
			potenz=35;
			modu=221;
			printf("\n");
			erg=basis.ModExp(potenz,modu);
			printf("\n");
			potenz=11;
			basis=erg.ModExp(potenz,modu);
			break;
		}
	} while (Auswahl!='0');

	return 0;
}

//Unterprogramm fr Primzahlenmen
void PrimZahlenProg(Primzahlen **prim)
{
	char Auswahl;
	do
	{
		printf("\n\n\n\n\n\tPrimzahlenmenue SimpleRSA");
		printf(        "\n\t=========================");
		printf(      "\n\n\t1) Primzahlen aus Datei lesen");
		printf(        "\n\t2) Primzahlen erzeugen/weitersuchen");
		printf(        "\n\t3) gefundene Primzahlen in Datei speichern");
		printf(      "\n\n\t0) Zurueck");
		printf(      "\n\n\tStatus: %d Primzahlen derzeit Verfuegbar",(int)(*prim)->Zahlen.Count);
		printf(      "\n\n\tAuswahl: ");

		Auswahl=(char)getchar();

		switch (Auswahl)
		{
		case '1':
			delete (*prim);
			(*prim)=new Primzahlen;
			(*prim)->Lesen();
			break;
		case '2':
			(*prim)->Suchen();
			break;
		case '3':
			(*prim)->Schreiben();
			break;
		}
	} while (Auswahl!='0');
}

//Unterprogramm fr Schlsselgeneratormen
void KeyProg(Primzahlen *prim)
{
	Key *key;
	key=new Key;
	char Puffer[256];

	char Auswahl;
	do
	{
		printf("\n\n\n\n\n\tSchluesselgeneratormenue SimpleRSA");
		printf(        "\n\t==================================");
		printf(      "\n\n\t1) Schluessel aus Datei lesen");
		printf(        "\n\t2) Schluessel erzeugen");
		printf(        "\n\t3) Schluessel in Datei speichern");
		printf(      "\n\n\t0) Zurueck");
		printf(      "\n\n\tPrimzahlstatus: %d Primzahlen derzeit Verfuegbar",(int)(prim->Zahlen.Count));
		printf(        "\n\tAktueller Schlssel:  Name:       %s",key->Name);
		if (key->IstPrivate)
			printf(    "\n\t                      Typ:        Private");
		else
			printf(    "\n\t                      Typ:        Public");
		key->Exponent.GetString(Puffer);
		printf(        "\n\t                      Exponent:   %s",Puffer);
		key->Modulowert.GetString(Puffer);
		printf(        "\n\t                      Modulowert: %s",Puffer);
		printf(      "\n\n\tAuswahl: ");

		Auswahl=(char)getchar();

		switch (Auswahl)
		{
		case '1':
			delete key;
			key=new Key;
			key->Lesen();			
			break;
		case '2':
			key->Generieren(prim);
			break;
		case '3':
			key->Schreiben();
			break;
		}
	} while (Auswahl!='0');
}

//Unterprogramm fr Nachrichtenverarbeitung
void NachrichtProg(Nachricht **msg)
{
	char Puffer[255];
	char Auswahl;
	do
	{
		printf("\n\n\n\n\n\tNachrichtenmenue SimpleRSA");
		printf(        "\n\t==========================");
		printf(      "\n\n\t1) Nachricht oeffnen");
		printf(        "\n\t2) Nachricht verschluesseln");
		printf(        "\n\t3) Nachricht entschluesseln");
		printf(      "\n\n\t0) Zurueck");
		(*msg)->Info(Puffer);
		printf(      "\n\n\tStatus: \n\t%s",Puffer);
		printf(      "\n\n\tAuswahl: ");

		Auswahl=(char)getchar();

		switch (Auswahl)
		{
		case '1':
			(*msg)->Oeffnen();
			break;
		case '2':
			(*msg)->Codieren();
			break;
		case '3':
			(*msg)->Decodieren();
			break;
		}
	} while (Auswahl!='0');
}
