// ####################################
// Implementierung der Klasse Nachricht
// ####################################

#include "Nachricht.h"
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <sys\stat.h>
#include "Key.h"

//Funktion um den Status herauszulesen
void Nachricht::Info(char *output)
{
	sprintf(output,"Dateiname: %s\n\t%s\n\t%d Bytes",Dateiname,Status,DateiLen);
}

//Funktion zum Auswhlen einer Datei von der Festplatte
int Nachricht::Oeffnen()
{
	//Neuen String fr den Dateinamen anlegen
	delete Dateiname;
	Dateiname=new char[255];
	
	//Dateinamen abfragen
	printf("\n\n\n\nBitte Dateinamen der Nachricht eingeben: ");
	scanf("%s",Dateiname);

	//Gewhlte Datei analysieren lassen...
	Analysieren();

	return 0;
}

//Funktion zum Codieren der gewhlten Nachricht mit einem beliebigen Schlssel
int Nachricht::Codieren()
{
	//Variablendeklarationen
	int Datei;					//DateiHandle
	int Output;					//DateiHandle
	char OutputDateiname[255];	//Name der Ausgabedatei
	char Zeile[255];			//Puffer fr eine Zeile
	VeryLong temp;				//Puffer fr einen Klartextblock
	VeryLong cotemp;			//Puffer fr einen codierten Block
	int Bytes=0;				//Byte-Zhler fr Schleife und Status
	int eof=0;					//Schleifenvariable: EndOfFile erreicht?

	//Einen Schlssel anlegen und einlesen
	Key key;
	if (key.Lesen()!=0)
		return -1;

	//Blockgrsse fr Verschlsselung aus Schlssellnge bestimmen
	int BlockSize=key.GetBlockSize();

	//Klartextdatei zum lesen (binr) ffnen
	// (realisiert mit Betriebssystemroutinen, weil Streamroutinen 
	//  fehlerhaft gelesen haben)
	Datei=_open(Dateiname,_O_BINARY|_O_RDONLY);
	if (Datei==-1)
	{
		printf("Die Datei \"%s\" konnte nicht geoeffnet werden!\n",Dateiname);
		printf("(Weiter mit Taste)");
		getchar();getchar();
		strcpy(Status,"Die Datei konnte nicht gefunden werden!");
		Dateityp='\0';
		return -1;
	}
	//Lnge der Datei bestimmen
	DateiLen=_filelength(Datei);

	//Erstellen des Dateinamens fr die Codierte Nachricht 
	// aus dem Ursprungsdateinamen
	sprintf(OutputDateiname,"%s.Chiffre.txt",Dateiname);

	//Ausgabedatei zum schreiben ffen
	Output=_open(OutputDateiname,_O_TEXT|_O_CREAT|_O_SEQUENTIAL|_O_TRUNC|_O_WRONLY,_S_IREAD|_S_IWRITE);
	if (Output==-1)
	{
		printf("Es kann nicht in \"%s\" geschrieben werden!\n",OutputDateiname);
		printf("Besteht sie bereits?");
		printf("(Weiter mit Taste)");
		getchar();getchar();
		return -1;
	}

	//Nachrichtenkopf schreiben
	sprintf(Zeile,"---SimpleRSA Nachricht---\n");
	_write(Output,Zeile,strlen(Zeile));
	//Schlsselnamen hinterlegen
	sprintf(Zeile,"KeyName: %s\n",key.Name);
	_write(Output,Zeile,strlen(Zeile));
	//Typ der Codierungsschlssels hinterlegen
	sprintf(Zeile,"Type:    %s\n",key.IstPrivate?"Private":"Public");
	_write(Output,Zeile,strlen(Zeile));
	//Lnge abspeichern
	sprintf(Zeile,"Laenge:  %d\n",DateiLen);
	_write(Output,Zeile,strlen(Zeile));
	//Kopfteil der codierten Nachricht abschliessen
	sprintf(Zeile,"---SimpleRSA Body---\n");
	_write(Output,Zeile,strlen(Zeile));

	printf("Starte Codierung mit Blockgroesse %d...\n",BlockSize);

	//So lange die Datei noch nicht zu Ende ist...
	while (eof==0)
	{
		//mehrere Zeichen als Block einlesen
		for (int i=0;i<BlockSize;i++)
		{
			//Wenn das lesen fehlschlgt, Verschlsselung beenden und
			//Fehlendes Zeichen fr Block als SPACE fllen
			if (_read(Datei,&Zeile[i],1)!=1)
			{
				eof=1;
				Zeile[i]=' ';
			}
		}
		//String (Block) Abschlieen
		Zeile[BlockSize]='\0';

		//Zeichen binr in TEMP kopieren
		temp.SetBin(Zeile,BlockSize);

		//TEMP zu COTEMP COdieren
		cotemp=temp.ModExp(key.Exponent,key.Modulowert);

		//codiertes COTEMP in einen String zum ausgeben konvertieren (HEX)
		cotemp.GetString(Zeile);

		//String ausgeben
		sprintf(Zeile,"%s\n",Zeile);
		_write(Output,Zeile,strlen(Zeile));

		//Zhler erhhen und Status aktualisieren
		Bytes+=BlockSize;
		if (Bytes>DateiLen) Bytes=DateiLen;
		printf("%d Bytes (%d%%) verarbeitet...\r",Bytes,Bytes*100/DateiLen);
	}
	printf("\nFertig!\n");
	printf("(Weiter mit Taste)");
	getchar();

	_close(Datei);
	_close(Output);

	//Neue Datei als Datei auswhlen und dann analysieren
	strcpy(Dateiname,OutputDateiname);
	Analysieren();
	return 0;
}

//Funktion zum Decodieren der gewhlten Nachricht mit einem beliebigen Schlssel
int Nachricht::Decodieren()
{
	//Prfen, ob dies eine verschlsselte Datei ist
	if (Dateityp!='C')
	{
		printf("Die Datei kann nicht decodiert werden, weil sie nicht\n");
		printf("verschluesselt ist!\n",Dateiname);
		printf("(Weiter mit Taste)");
		getchar();getchar();
		return -1;
	}

	//Variablendeklarationen
	int Datei;					//DateiHandle
	int Output;					//DateiHandle
	char OutputDateiname[255];	//Name der Ausgabedatei
	char Zeile[255];			//Puffer fr eine Zeile
	VeryLong temp;				//Puffer fr einen codierten Block
	VeryLong detemp;			//Puffer fr einen decodierten Klartextblock
	int Bytes=0;				//Byte-Zhler fr Schleife und Status

	//Einen Schlssel anlegen und einlesen
	Key key;
	if (key.Lesen()!=0)
		return -1;

	//Blockgrsse fr Verschlsselung aus Schlssellnge bestimmen
	int BlockSize=key.GetBlockSize();

	//Codierte Datei zum lesen ffnen
	Datei=_open(Dateiname,_O_TEXT|_O_RDONLY);
	if (Datei==-1)
	{
		printf("Die Datei \"%s\" konnte nicht geoeffnet werden!\n",Dateiname);
		printf("(Weiter mit Taste)");
		getchar();getchar();
		strcpy(Status,"Die Datei konnte nicht gefunden werden!");
		Dateityp='\0';
		return -1;
	}

	//Erstellen des Dateinamens fr die Decodierte Nachricht 
	// aus dem aktuellen Dateinamen
	sprintf(OutputDateiname,"%s.Klar.txt",Dateiname);
	
	//Klartextdatei zum schreiben (binr) ffnen
	// (realisiert mit Betriebssystemroutinen, weil Streamroutinen 
	//  fehlerhaft geschrieben haben)
	Output=_open(OutputDateiname,_O_BINARY|_O_CREAT|_O_SEQUENTIAL|_O_TRUNC|_O_WRONLY,_S_IREAD|_S_IWRITE);
	if (Output==-1)
	{
		printf("Es kann nicht in \"%s\" geschrieben werden!\n",OutputDateiname);
		printf("(Weiter mit Taste)");
		getchar();getchar();
		return -1;
	}

	printf("Starte Decodierung mit Blockgroesse %d...\n",BlockSize);

	//Die 5 Kopfzeilen berlesen (wurden ja schon analysiert()...)
	int i=5;
	while (i>0 && !_eof(Datei))
	{
		_read(Datei,Zeile,1);
		if (Zeile[0]=='\n') i--;
	}

	//So lange die Datei noch nicht zu Ende ist...
	while (!_eof(Datei))
	{
		//Eine Zeile einlesen und das ENTER abschneiden
		i=0;
		while (_read(Datei,&Zeile[i],1)==1 && Zeile[i]!='\n') i++;
		Zeile[i]='\0';

		//Eingelesene HEX-Zahl in VeryLong kopieren (als HEX interpretieren)
		temp.SetString(Zeile);

		//Wert dechiffrieren
		detemp=temp.ModExp(key.Exponent,key.Modulowert);

		//Wert in Binrstring kopieren
		detemp.GetBin(Zeile,BlockSize);

		//String in Datei schreiben (und Dateiende bercksichtigen)
		if (Bytes+BlockSize>DateiLen) BlockSize=DateiLen-Bytes;
		_write(Output,Zeile,BlockSize);

		//Zhler erhhen und Status aktualisieren
		Bytes+=BlockSize;
		printf("%d Bytes (%d%%) verarbeitet...\r",Bytes,Bytes*100/DateiLen);
	}
	printf("\nFertig!\n");
	printf("(Weiter mit Taste)");
	getchar();

	_close(Datei);
	_close(Output);

	//Neue Datei als Datei auswhlen und dann analysieren
	strcpy(Dateiname,OutputDateiname);
	Analysieren();
	return 0;
}

//Funktion zum Analysieren der gewhlten Nachricht
void Nachricht::Analysieren()
{
	//Variablendeklaratonen
	FILE *Datei;
	char Zeile[255];

	//Datei ffnen
	Datei=fopen(Dateiname,"r");
	if (Datei==NULL)
	{
		printf("Die Datei \"%s\" konnte nicht geoeffnet werden!\n",Dateiname);
		printf("(Weiter mit Taste)");
		getchar();getchar();
		strcpy(Status,"Die Datei konnte nicht gefunden werden!");
		Dateityp='\0';
		return;
	}

	//Eine Zeile lesen und daran entscheiden, 
	// ob es eine verschlsselte Nachricht ist
	fgets(Zeile,sizeof(Zeile),Datei);
	if (strcmp(Zeile,"---SimpleRSA Nachricht---\n")==0)
	{
		//Zeile mit Schlsselnamen lesen und diesen kopieren
		fgets(Zeile,sizeof(Zeile),Datei);
		Zeile[strlen(Zeile)-1]='\0';
		strcpy(KeyName,&Zeile[9]);

		//Schauen, ob es mit Privatem oder ffentlichen Schlssel 
		// verschlsselt wurde
		fgets(Zeile,sizeof(Zeile),Datei);
		if (strcmp(Zeile,"Type:    Private\n")==0)
		{
			IstPrivateKey=true;
		}
		else
		{
			IstPrivateKey=false;
		}

		//Dateilnge der originaldatei ermitteln
		fgets(Zeile,sizeof(Zeile),Datei);
		DateiLen=atoi(&Zeile[9]);

		//Dateityp setzen
		Dateityp='C';

		//Status aktualisieren
		sprintf(Status,"Die Nachricht ist mit dem Schluessel \"%s\" (%s) \n\tVerschluesselt",
			KeyName, IstPrivateKey?"Private":"Public");
	}
	else
	{
		//Die Datei ist also nicht verschlsselt, also Status neu setzen...
		strcpy(Status,"Die Nachricht besteht aus unverschluesseltem Text.");

		//Datei nochmals ffnen und Dateilnge auslesen
		int Datei2;
		Datei2=_open(Dateiname,_O_BINARY|_O_RDONLY);
		DateiLen=_filelength(Datei2);
		_close(Datei2);

		//Dateityp setzen
		Dateityp='P';
	}

	fclose(Datei);
}

//Konstruktor
Nachricht::Nachricht()
{
	Dateiname=new char[1];
	Dateiname[0]='\0';
	Status=new char[255];
	strcpy(Status,"Keine Datei ausgewaehlt.");
	KeyName=new char[1];
	KeyName[0]='\0';
	Dateityp='\0';
	DateiLen=0;
}

//Destruktor
Nachricht::~Nachricht()
{
	delete Dateiname;
	delete Status;
	delete KeyName;
}
