// #####################################
// Implementierung der Klasse Primzahlen
// #####################################

#include <stdio.h>
#include <conio.h>
#include "VeryLong.h"
#include "DynamischeListe.h"
#include "Primzahlen.h"

//Startet die Suche nach weiteren Primzahlen
// basierend auf den schon verfgbaren Primzahlen
void Primzahlen::Suchen()
{
	//Variablendeklarationen
	VeryLong Position;
	VeryLong Null;
	Null=0;
	VeryLong Prim;
	VeryLong Gefunden;
	Gefunden=Position;

	//Nach vorhandenen Primzahlen schauen
	Position=Zahlen.GetFirst();
	if (Position==0)
	{
		//...Wenn die Liste bisher leer ist, dann neu starten
		Position=2;
		Zahlen.AddNext(Position);
	}
	else
	{
		//...Ansonsten hinter der aktuell letzten Primzahl starten
		Position=Zahlen.GetLast();
	}

	printf("\n\n\n\nSuche Primzahlen... (Taste druecken zum Abbrechen)\n");

	//So lange keine Taste gedrckt wurde...
	while (_kbhit()==0)
	{
		Position=Position+1;

		//Von der ersten Primzahl an alle bisher gefundenen Primzahlen
		//auf Teiler prfen
		Prim=Zahlen.GetFirst();
		while (Prim!=Null && Position%Prim!=Null)
			Prim=Zahlen.GetNext();

		//Wenn Prim==0 ist, dann wurden alle Primzahlen als Teiler erfolglos durchprobiert
		// und die Zahl ist wohl eine Primzahl...
		if (Prim==0)
		{
			Gefunden=Position;
			Zahlen.AddNext(Gefunden);
		}
		printf("\rAnzahl Primzahlen: %d   Letzte Primzahl: %d   Suchposition: %d",(int)Zahlen.Count,(int)Gefunden,(int)Position);
	}
	printf("\n(Weiter mit Taste)");
	getchar();getchar();getchar();
	printf("\n\n\n\n");
}

//Funktion zum Einlesen von Primzahlen aus einer Datei
int Primzahlen::Lesen()
{
	//Variablendeklarationen
	char Dateiname[255];
	char Zeile[255];
	VeryLong PrimZahl;

	//Dateinamesn zum Einlesen abfragen
	printf("\n\n\n\nBitte Dateinamen zum Einlesen eingeben: ");
	scanf("%s",Dateiname);

	//Datei ffnen
	FILE *PrimListe;
	PrimListe=fopen(Dateiname,"r");
	if (PrimListe==NULL)
	{
		printf("Die Datei \"%s\" konnte nicht geoeffnet werden!\n",Dateiname);
		printf("(Weiter mit Taste)");
		getchar();getchar();
		return -1;
	}
	
	//Jede Zeile bis zum Dateiende lesen
	while (feof(PrimListe)==0)
	{
		//Zeile einlesen
		fgets(Zeile,254,PrimListe);
		//String konvertieren
		PrimZahl.SetString(Zeile);
		//Wenn Konvertierung OK, dann liste hinzufgen
		if ((int)PrimZahl!=0)
		{
			Zahlen.AddNext(PrimZahl);
		}
	}

	printf("OK. %d Primzahlen gelesen.\n",(int)Zahlen.Count);
	printf("(Weiter mit Taste)");
	getchar();getchar();
	fclose(PrimListe);
	return 0;
}

//Funktion zum Schreiben der Primzahlenliste in eine Datei
int Primzahlen::Schreiben()
{
	//Variablendeklarationen
	char Dateiname[255];
	char Zeile[255];
	VeryLong PrimZahl;

	//Dateinamen abfragen
	printf("\n\n\n\nBitte Dateinamen zum Ausgeben eingeben: ");
	scanf("%s",Dateiname);

	//Datei ffnen
	FILE *PrimListe;
	PrimListe=fopen(Dateiname,"w");
	if (PrimListe==NULL)
	{
		printf("Die Datei \"%s\" konnte nicht geoeffnet werden!\n",Dateiname);
		printf("(Weiter mit Taste)");
		getchar();getchar();
		return -1;
	}
	
	//Jedes Element der Liste schreiben
	PrimZahl=Zahlen.GetFirst();
	do
	{
		//Zahl in String konvertieren
		PrimZahl.GetString(Zeile);
		//String in Datei schreiben
		fprintf(PrimListe,"%s\n",Zeile);
		//Nchste Zahl holen
		PrimZahl=Zahlen.GetNext();
	} while ((int)PrimZahl!=0);

	printf("OK. %d Primzahlen geschrieben.\n",(int)Zahlen.Count);
	printf("(Weiter mit Taste)");
	getchar();getchar();
	fclose(PrimListe);
	return 0;
}

//Konstruktor
Primzahlen::Primzahlen()
{
}

//Destruktor
Primzahlen::~Primzahlen()
{
}
